#
# NDK build file
#
# Written by Ant-ON, 2021
#

LOCAL_PATH := $(call my-dir)
include $(CLEAR_VARS)

LOCAL_MODULE := ext2fs-1.46

LOCAL_C_INCLUDES := $(LOCAL_PATH) \
	$(LOCAL_PATH)/../libfs/include \
	$(LOCAL_PATH)/../libbm/include

LOCAL_SRC_FILES := \
	ext2_fs.c \
	blk_io.c \
	ext2fs/ext2_err.c \
	ext2fs/alloc.c \
	ext2fs/alloc_sb.c \
	ext2fs/alloc_stats.c \
	ext2fs/badblocks.c \
	ext2fs/bitmaps.c \
	ext2fs/bitops.c \
	ext2fs/blkmap64_ba.c \
	ext2fs/blkmap64_rb.c \
	ext2fs/blknum.c \
	ext2fs/block.c \
	ext2fs/bmap.c \
	ext2fs/crc16.c \
	ext2fs/crc32c.c \
	ext2fs/csum.c \
	ext2fs/closefs.c \
	ext2fs/dirblock.c \
	ext2fs/dirhash.c \
	ext2fs/dir_iterate.c \
	ext2fs/expanddir.c \
	ext2fs/ext_attr.c \
	ext2fs/extent.c \
	ext2fs/fallocate.c \
	ext2fs/fileio.c \
	ext2fs/freefs.c \
	ext2fs/gen_bitmap.c \
	ext2fs/gen_bitmap64.c \
	ext2fs/get_num_dirs.c \
	ext2fs/hashmap.c \
	ext2fs/i_block.c \
	ext2fs/ind_block.c \
	ext2fs/initialize.c \
	ext2fs/inline.c \
	ext2fs/inline_data.c \
	ext2fs/inode.c \
	ext2fs/io_manager.c \
	ext2fs/link.c \
	ext2fs/lookup.c \
	ext2fs/mmp.c \
	ext2fs/mkdir.c \
	ext2fs/mkjournal.c \
	ext2fs/namei.c \
	ext2fs/newdir.c \
	ext2fs/nls_utf8.c \
	ext2fs/openfs.c \
	ext2fs/punch.c \
	ext2fs/rbtree.c \
	ext2fs/read_bb.c \
	ext2fs/rw_bitmaps.c \
	ext2fs/sha512.c \
	ext2fs/symlink.c \
	ext2fs/unlink.c \
	ext2fs/valid_blk.c

ifeq ($(TARGET_ARCH_ABI),armeabi-v7a)
HW_CFLAGS :=
endif
ifeq ($(TARGET_ARCH_ABI),arm64-v8a)
#HW_CFLAGS := -DANDROID_HW -DHW_ARMV8
endif
ifeq ($(TARGET_ARCH_ABI),x86)
HW_CFLAGS := -DANDROID_HW -DHW_X86
endif
ifeq ($(TARGET_ARCH_ABI),x86_64)
HW_CFLAGS := -DANDROID_HW -DHW_X86
endif

MAIN_CFLAGS := -D_GNU_SOURCE
# -DOMIT_COM_ERR

LOCAL_CFLAGS += -O2 $(MAIN_CFLAGS) $(HW_CFLAGS)

# Remove unused code
#LOCAL_CFLAGS += -fvisibility=hidden -ffunction-sections -fdata-sections -Wl,--gc-sections
#LOCAL_CPPFLAGS += -fvisibility=hidden -fvisibility-inlines-hidden -ffunction-sections -fdata-sections -Wl,--gc-sections
#LOCAL_LDFLAGS += -Wl,--gc-sections -Wl,--strip-all -Wl,-z,nocopyreloc

LOCAL_SHARED_LIBRARIES :=
LOCAL_STATIC_LIBRARIES := hw

LOCAL_EXPORT_C_INCLUDES := $(LOCAL_PATH)/include

LOCAL_LDLIBS := -llog

include $(BUILD_SHARED_LIBRARY)
